
/**
 * Primeira implementao de uma turma de alunos.
 * Assume que a turma  mantida num array.
 * 
 * @author Antnio Nestor Ribeiro
 * @version 2006/03/20
 */
public class Turma
{
	private String designacao;
	private Aluno[] lstalunos;
    private int capacidade;
	
	//variaveis internas para controlo do numero de alunos
    private int ocupacao;

	
	//se no for especificado o tamanho da turma usa-se esta constante
	private static final int capacidade_inicial = 20;

	/**
	 * Constructor for objects of class Turma
	 */
	public Turma()
	{
		this.designacao = new String();
		this.lstalunos = new Aluno[capacidade_inicial];
		this.capacidade = capacidade_inicial;
		this.ocupacao = 0;
	}
	
	public Turma(String designacao, int tamanho) {
         this.designacao = designacao;
         this.lstalunos = new Aluno[tamanho];
         this.capacidade = tamanho;
         this.ocupacao = 0;
    }

    
    public String getDesignacao() {
        return this.designacao;
    }
    
    public int getCapacidade() {
        
        return this.capacidade;
    }
    
    public boolean temCapacidade() {
        return (this.lstalunos.length > this.ocupacao);
    }
    
    
    /**
	 * Este mtodo assume que se verifique previamente se
	 * ainda existe espao para mais um aluno na turma.
	 * 
	 * Em futuras verses desta classe poderemos fazer internamente a 
	 * gesto das situaes de erro. Neste momento assume-se que a 
	 * pr-condio  verdadeira.
	 * 
	 * Este mtodo dever ser reescrito em futuras implementaes 
	 * para evitar potenciais quebras de encapsulamento.
	 * 
	 */
    public void insereAluno(Aluno umAluno) {
    
        
        this.lstalunos[this.ocupacao] = umAluno; //encapsulamento ??
        this.ocupacao++;
    }
        
    /**
	 * Mtodo toString por questes de compatibilizao com as restantes
	 * classes do Java.
	 * 
	 * Como o toString  estrutural e a classe Aluno tem esse mtodo 
	 * implementado o resultado  o esperado.
	 * 
	 */
    public String toString() {
        StringBuffer sb = new StringBuffer();
        
        sb.append("Designao: "); sb.append(this.designacao+"\n");
        sb.append("Capacidade: "); sb.append(this.capacidade+"\n");
        sb.append("Alunos: "+"\n"); sb.append(this.lstalunos.toString());
        
        return sb.toString();
    }       
    
    
    //Outros mtodos:
    //a) verificar se um aluno existe na turma
    //b) remover aluno dado o nmero
    //c) inserir um conjunto de alunos na turma
    
}
